/* caribou-1.0.vapi generated by valac 0.12.0, do not modify. */

[CCode (cprefix = "Caribou", lower_case_cprefix = "caribou_", gir_namespace = "_Caribou", gir_version = "1.0")]
namespace Caribou {
	[CCode (cheader_filename = "caribou.h")]
	public class ColumnModel : Caribou.ScannableGroup, Caribou.IScannableItem, Caribou.IKeyboardObject {
		public ColumnModel ();
		public Caribou.KeyModel first_key ();
		public Caribou.KeyModel get_key (int index);
		public override Caribou.IScannableItem[] get_scan_children ();
	}
	[CCode (cheader_filename = "caribou.h")]
	public class GroupModel : GLib.Object, Caribou.IKeyboardObject {
		public string group;
		public string variant;
		public GroupModel (string group, string variant);
		public static string create_group_name (string group, string variant);
		public Caribou.LevelModel get_level (string level_name);
		public string[] get_levels ();
		public string active_level { get; private set; }
	}
	[CCode (cheader_filename = "caribou.h")]
	public class KeyModel : GLib.Object, Caribou.IScannableItem, Caribou.IKeyboardObject {
		public KeyModel (string name);
		public void activate ();
		public Caribou.KeyModel[] get_extended_keys ();
		public void press ();
		public void release ();
		public string align { get; set; }
		public uint keyval { get; private set; }
		public string name { get; private set; }
		public bool show_subkeys { get; private set; }
		public string toggle { get; set; }
		public double width { get; set; }
		public signal void key_hold ();
		public signal void key_hold_end ();
		public signal void key_pressed ();
		public signal void key_released ();
	}
	[CCode (cheader_filename = "caribou.h")]
	public class KeyboardModel : GLib.Object, Caribou.IKeyboardObject {
		public KeyboardModel ();
		public Caribou.GroupModel get_group (string group_name);
		public string[] get_groups ();
		public string active_group { get; private set; }
		public string keyboard_type { get; construct; }
	}
	[CCode (cheader_filename = "caribou.h")]
	[DBus (name = "org.gnome.Caribou.Keyboard")]
	public abstract class KeyboardService : GLib.Object {
		public KeyboardService ();
		public abstract void hide ();
		protected virtual void name_lost (string name);
		protected void register_keyboard (string name);
		public abstract void set_cursor_location (int x, int y, int w, int h);
		public abstract void set_entry_location (int x, int y, int w, int h);
		public abstract void show ();
	}
	[CCode (cheader_filename = "caribou.h")]
	public class LevelModel : Caribou.ScannableGroup, Caribou.IKeyboardObject {
		public LevelModel (string mode);
		public Caribou.RowModel[] get_rows ();
		public override Caribou.IScannableItem[] get_scan_children ();
		public string mode { get; private set; }
		public signal void level_toggled (string new_level);
	}
	[CCode (cheader_filename = "caribou.h")]
	public class RowModel : Caribou.ScannableGroup, Caribou.IScannableItem, Caribou.IKeyboardObject {
		public RowModel ();
		public Caribou.ColumnModel[] get_columns ();
		public override Caribou.IScannableItem[] get_scan_children ();
	}
	[CCode (cheader_filename = "caribou.h")]
	public abstract class ScannableGroup : GLib.Object, Caribou.IScannableGroup {
		public ScannableGroup ();
		public virtual Caribou.IScannableItem? child_select ();
		public abstract Caribou.IScannableItem[] get_scan_children ();
	}
	[CCode (cheader_filename = "caribou.h")]
	public class Scanner : GLib.Object {
		public Scanner ();
		public void reset ();
		public void set_keyboard (Caribou.KeyboardModel keyboard);
		public bool autorestart { get; set construct; }
		public bool bind_settings { get; construct; }
		public bool inverse_scanning { get; set construct; }
		public string keyboard_key { get; set construct; }
		public int mouse_button { get; set construct; }
		public int scan_cycles { get; set construct; }
		public bool scan_enabled { get; set construct; }
		public int scan_grouping { get; set construct; }
		public double step_time { get; set construct; }
		public string switch_device { get; set construct; }
	}
	[CCode (cheader_filename = "caribou.h")]
	public class XAdapter : GLib.Object {
		[CCode (cheader_filename = "caribou.h")]
		public delegate void KeyButtonCallback (uint keybuttoncode, bool pressed);
		public XAdapter ();
		public uint get_current_group (out string group_name, out string variant_name);
		public static Caribou.XAdapter get_default ();
		public void get_groups (out string[] group_names, out string[] variant_names);
		public void keyval_press (uint keyval);
		public void keyval_release (uint keyval);
		public void mod_latch (uint mask);
		public void mod_unlatch (uint mask);
		public void register_button_func (uint button, Caribou.XAdapter.KeyButtonCallback? func);
		public void register_key_func (uint keyval, Caribou.XAdapter.KeyButtonCallback? func);
		public signal void group_changed (uint gid, string group, string variant);
		public signal void modifiers_changed (uint modifiers);
	}
	[CCode (cheader_filename = "caribou.h")]
	public interface IKeyboardObject : GLib.Object {
		public abstract Caribou.IKeyboardObject[] get_children ();
		public virtual Caribou.KeyModel[] get_keys ();
		public signal void key_activated (Caribou.KeyModel key);
	}
	[CCode (cheader_filename = "caribou.h")]
	public interface IScannableGroup : GLib.Object {
		public abstract Caribou.IScannableItem? child_select ();
		public abstract Caribou.IScannableItem? child_step (int cycles);
		public abstract Caribou.IScannableItem[] get_scan_children ();
		public abstract Caribou.IScannableItem[] get_selected_path ();
		public abstract Caribou.IScannableItem[] get_step_path ();
		public abstract void scan_reset ();
		public abstract Caribou.ScanGrouping scan_grouping { get; set; }
		public signal void scan_cleared ();
		public signal void selected_item_changed (Caribou.IScannableItem? selected_item);
		public signal void step_item_changed (Caribou.IScannableItem? step_item);
	}
	[CCode (cheader_filename = "caribou.h")]
	public interface IScannableItem : GLib.Object {
		public abstract bool scan_selected { get; set; }
		public abstract bool scan_stepping { get; set; }
	}
	[CCode (cprefix = "CARIBOU_SCAN_GROUPING_", cheader_filename = "caribou.h")]
	public enum ScanGrouping {
		NONE,
		SUBGROUPS,
		ROWS,
		LINEAR
	}
}
